/*
 * Cr le 12 fvr. 2004
 *
 * SimpleViewerJava3D
 */

import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.SimpleUniverse;

/**
 * @author Olivier Lamotte
 *
 * Cration d'un viewer Java3D  partir de la classe SimpleUniverse
 */
public class SimpleViewerJava3D extends Canvas3D
{
	
	static final long serialVersionUID = 0l;
	
	public SimpleViewerJava3D()
	{
		// Cration du Canvas3D
		super(SimpleUniverse.getPreferredConfiguration());

		// Cration de la Scne
		BranchGroup scene = createSceneGraph();
		
		// Optimisation des calculs
		scene.compile();
		
		// Cration de l'univers conteneru de la scne 3D
		SimpleUniverse simpleU = new SimpleUniverse(this);
		
		// Positionnement du plan de projection
		simpleU.getViewingPlatform().setNominalViewingTransform();
		
		// Ajout de la scne
		simpleU.addBranchGraph(scene);
	}
	
	private BranchGroup createSceneGraph()
	{
		// Cration du BranchGroup principal
		BranchGroup bgRoot = new BranchGroup();

		// ========================
		// Cration du premier cube
		// ------------------------
		
		ColorCube cube = new ColorCube(0.2);
		//bgRoot.addChild(cube);
		
		// ========================

		// ================
		// Rotation du cube
		// ----------------
		
		//Transform3D transform = new Transform3D();
		//transform.rotX(Math.PI/4.0d);
		
		TransformGroup tg = new TransformGroup();
		tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		bgRoot.addChild(tg);

		Transform3D tx = new Transform3D();
		tx.rotX(Math.PI/2);
		tx.rotY(0);
		RotationInterpolator rx = new RotationInterpolator(
			new Alpha(-1,2000), tg, tx,
			0.0f,(float)(2*Math.PI)
			);
		rx.setSchedulingBounds(new BoundingBox());
		tg.addChild(rx);
		
		/*
		Transform3D ty = new Transform3D();
		ty.rotX(Math.PI/2);
		RotationInterpolator ry = new RotationInterpolator(
			new Alpha(-1,2000), tg, ty,
			0.0f,(float)(2*Math.PI)
			);
		ry.setSchedulingBounds(new BoundingBox());
		tg.addChild(ry);
		*/
		
		tg.addChild(cube);

		// ================
		
		return bgRoot;
	}
}
