/**
 * ---------------------
 * ViewerJava3DMain.java
 * ---------------------
 *
 * @author 		Olivier Lamotte
 * @date 		02/2004
 */


import java.awt.*;
import java.awt.event.*; 
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JButton;

/**
 * Classe principale pour le lancement d'un viewer Java3D
 */
public class ViewerJava3DMain extends JFrame
{
	
	private static final long serialVersionUID = 0;
	
	// Fentre principale
	private static JFrame mainFrame;
	private static ViewerJava3D viewer;

	/**
	 * Main
	 */	
	public static void main(String[] args)
	{
		// Configuration de la fentre d'affichage
		// ---------------------------------------
		//
		// Dimensions
		Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();

		// Cration de la fentre principale
		mainFrame = new JFrame("IN55 TP1 - Initiation  Java3D - Exo 1");
		
		// Initialisation de la fentre
		mainFrame.getContentPane().setLayout(new BorderLayout());
		mainFrame.setResizable(false);
		
		// Dimensionnement et positionnement de la fentre principale
		double screenWidth  = screenDim.getWidth();
		double screenHeight = screenDim.getHeight();
		mainFrame.setBounds((int)(screenWidth-800)/2, (int)(screenHeight-660)/2, 800, 660);

		// Lancement de l'application
		new ViewerJava3DMain();

		// Affichage de la fentre
		mainFrame.setVisible(true);
		
		System.out.println("IN55 TP1 - Initiation  Java3D - Exo 1");
		System.out.close();
	}
	
	/**
	 * Constructeur
	 */
	public ViewerJava3DMain()
	{
		// Gestion de la fermeture de la fentre
		// -------------------------------------
		mainFrame.addWindowListener(
			new WindowAdapter() 
			{
				public void windowClosing(WindowEvent event)
				{
					// Instruction de fermeture de l'application
					close();
				}
			}
		);
		
		// Cration et affichage d'une barre de boutons
		JPanel bar = new JPanel();
		JButton showGrid = new JButton("Switch grid");
		showGrid.addActionListener(new GridListener());
		bar.add(showGrid);
		mainFrame.getContentPane().add(BorderLayout.BEFORE_FIRST_LINE, bar);
		
		// Cration et ajout du viewer
		viewer = new ViewerJava3D();
		mainFrame.getContentPane().add(BorderLayout.CENTER, viewer);
	}
	
    class GridListener implements ActionListener { 
        public void actionPerformed(ActionEvent e) {
    		viewer.switchGrid();
        } 
    } 	
	
	/**
	 * Fermeture de l'application
	 */
	private void close()
	{
		System.exit(0);
	}
}