/*
 * Cr le 12 fvr. 2004
 *
 * ViewerJava3D
 */
package fr.utbm.gi.in55.tp;

import java.awt.*;
import java.awt.image.*;
import javax.swing.JPanel;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.keyboard.*;

/**
 * @author Olivier Lamotte
 *
 * Cration d'un viewer en redfinissant les branches visualisation et objet
 */
public class ViewerJava3D extends JPanel
{
	/** BranchGroup de la scne */
	private TransformGroup contentTransformGroup = null;

	/** Group du sceneGraph */
	private Group sceneGroup = null;
	

	/**
	 * Constructeur
	 */
	public ViewerJava3D()
	{
		// Initialisation du JPanel
		super();
		setLayout(new BorderLayout());
		
		// Cration du contexte graphique
		// L'cran
		GraphicsDevice GD = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
		// ?
		GraphicsConfigTemplate3D GC3D = new GraphicsConfigTemplate3D();
		// La config graphique
		GraphicsConfiguration config = GD.getBestConfiguration(GC3D);
		
		// Cration du canvas
		Canvas3D canvas = new Canvas3D(config);
		
		// Ici, on a un canvas 3D, pas vraiment spcifique  Java3D
		// Reste  crer l'univers de Java 3D
		
		// Ajout du Canvas3D au centre du JPanel
		add(BorderLayout.CENTER, canvas);
		
		// Cration de l'univers
		VirtualUniverse universe = new VirtualUniverse();
		
		// Cration du Locale
		Locale locale = new Locale(universe);
		
		// Cration et ajout de la branche de visualisation
		locale.addBranchGraph(createViewBranch(canvas));
		
		// Cration et ajout de la branche objet
		locale.addBranchGraph(createObjectBranch());
	}

	/**
	 * createViewBranch
	 *
	 * Cration de la branche de visualisation
	 * @param canvas
	 * @return BranchGroup visualisation
	 */	
	private BranchGroup createViewBranch(Canvas3D canvas)
	{
		// Cration de la banche View
		BranchGroup viewBranch = new BranchGroup();
        
		// Positionnement du point de vue
		Transform3D viewPointTranslation = new Transform3D();
		Transform3D viewPointRotation = new Transform3D();
        
		viewPointTranslation.set(new Vector3f(0.0f, 1.5f, 10.0f));
		viewPointRotation.rotX(-0.2);
		
		// Composition des transformations
		viewPointTranslation.mul(viewPointRotation);
        
		// Cration du TransformGroup View
		TransformGroup viewTransformGroup = new TransformGroup(viewPointTranslation);
		viewTransformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		viewTransformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		
		// Mise en place des clippings (proche et distant)
		// nb : Clipping proche = pour compenser l'absence de stro (une seule
		// camra)
		
		// Cration du ViewPlatform
		ViewPlatform viewPlatform = new ViewPlatform();
        
		// Cration de la vue
		View view = new View();
		view.setBackClipDistance(100000);
		view.attachViewPlatform(viewPlatform);
		view.addCanvas3D(canvas);
		view.setPhysicalBody(new PhysicalBody());
		view.setPhysicalEnvironment(new PhysicalEnvironment());

		// Constitution de la branche visualisation (Attention  l'ordre des tapes)
		viewTransformGroup.addChild(viewPlatform);
		viewBranch.addChild(viewTransformGroup);
		viewBranch.compile();		
		
		return (viewBranch);
	}
	
	/**
	 * createObjectBranch
	 * 
	 * Cration de la branche contenant les objets
	 * @return BranchGroup contenant les objets
	 */
	private BranchGroup createObjectBranch()
	{
		// Cration de la contentBranch
		BranchGroup contentBranch = new BranchGroup();
					
		// Cration du TransformGroup content
		
		// Cration du groupe scne
		
		// Cration de la Scene
		// --------------------
		
		
		// Constitution de la branche scne
		// --------------------------------
		
		
		return contentBranch;
	}
}
